;------------------------------------------------------------------------------
; obt@ɓ]
;------------------------------------------------------------------------------
; [input]
; B=
; DE=`̐擪AhX
; [output]
; HL=obt@擪AhXiOŌŒj
;------------------------------------------------------------------------------
SET_STRINGBUFFER:

; `GANA
	LD	C, B			;ق
	LD	HL, BUFFER
	PUSH	HL
	LD	B, STRBUF_LEN
	LD	A, " "
CLEAR_STRBUF:
	LD	(HL), A
	INC	HL
	DJNZ	CLEAR_STRBUF
	POP	HL

; `GAɃRs[
	LD	B, C			; ӂ
	PUSH	HL

SET_STRBUF01:
	LD	A, (DE)			; 0Œ`I
	AND	A
	JR	Z, SET_STRBUF02

	LD	(HL), A			; Rs[s
	INC	HL
	INC	DE
	DJNZ	SET_STRBUF01

SET_STRBUF02:
	POP	HL

	RET

;------------------------------------------------------------------------------
; \
;------------------------------------------------------------------------------
K_COUNTER:
	DB	$00
;------------------------------------------------------------------------------
; input:  A=\(A\$00ꍇ́A̎_ŏI)
;        BC=eLXgVRAMAhX ($3000`$37ff)
;        HL=̃AhX
PRINT_KANJI:
	LD	(K_COUNTER), A		; JE^lۑ

	LD	A, (HL)
	INC	HL

	AND	A
	RET	Z			; $00̏ꍇ͏I

	CP	$81-1			; $81`$9f/$e0`$ef  ShiftJIS
	JR	C, PRINTASCII		; $81ȉASCII

	CP	$9f+1
	JR	C, PRINTSJIS		; $81ȏ$9fȉShiftJIS

	CP	$e0-1
	JR	C, PRINTASCII		; $e0ȉASCII

	CP	$ef+1			
	JR	C, PRINTSJIS		; $e0ȏ$efȉShiftJIS

	JR	PRINTASCII		; ̑ASCII

PRINT_KANJI01:
	LD	A, (K_COUNTER)		; JE^擾
PRINT_KANJI03:
	DEC	A
	RET	Z			; JE^0Ȃ߂
	BIT	7, A
	RET	NZ			; JE^ꂵ߂

	JR	PRINT_KANJI

	RET

;------------------------------------------------------------------------------
PRINTASCII:
	CALL	ESCAPE_CONTROL

PRINTASCII01:
	SET	3, B		; BC=$3800`
	PUSH	AF
	XOR	A
	OUT	(C), A
	POP	AF
	RES	3, B		; BC=$3000`
	OUT	(C), A


	INC	BC
	JR	PRINT_KANJI01

;------------------------------------------------------------------------------
PRINTSJIS:
	LD	D, A		; DE=SJIS
	LD	E, (HL)
	INC	HL

	DI			; BIOS CALL͊荞݂Ȃ

	PUSH	BC
	LD	BC, $2f81	; SJIS->JISϊ/DE=JIS
	RST	18H		; BIOS CALL

;	LD	A, $76
;	LD	(0F881H), A

	LD	BC, $2fb6	; JIS->VRAMAhXϊ
	RST	18H		; BIOS CALL
	POP	BC

	EI

	JR	C, KANJI_SKIP	; G[͕\Ȃ

	; 8bit$3000`$37ffOUT
	OUT	(C), E
	INC	BC


	OUT	(C), E
	DEC	BC
	
	; 8bit$3800`$3fffOUT
	SET	3, B		; BC=$3800`

	SET	7, D		; tOon
	RES	6, D		; 
	OUT	(C), D
	INC	BC
	SET	6, D		; E
	OUT	(C), D
	INC	BC

	RES	3, B		; BC=$3000`

	JR	PRINT_KANJI02

;------------------------------------------------------------------------------
KANJI_SKIP:
	XOR	A	; 0
	LD	D, 32	; p
	LD	E, 2	; 2JԂ

KANJI_SKIP01:
	OUT	(C), D
	SET	3, B		; BC=$3800`
	OUT	(C), A
	RES	3, B		; BC=$3000`
	INC	BC
	DEC	E
	JR	NZ, KANJI_SKIP01

;------------------------------------------------------------------------------
PRINT_KANJI02:
	LD	A, (K_COUNTER)	; 2JE^񂷁i1̓C[`decj
	DEC	A
	JR	PRINT_KANJI03
	
;------------------------------------------------------------------------------
ESCAPE_CONTROL:
	CP	$20
	RET	NC
ESCAPE_CONTROL01:
	LD	A, $20			; 00H`1FH(Rg[R[h)̏ꍇA20H(p)ɒu
	RET

;------------------------------------------------------------------------------
PRINT_ANK:
	LD	A, (HL)
	CALL	ESCAPE_CONTROL
	OUT	(C), A
	INC	HL
	INC	BC
	DEC	D
	JR	NZ, PRINT_ANK
	RET

